<!--
  Author: Guillaume Valmont
  Date : March 23, 2024
  Licence: CC-BY-SA 4.0
  https://forge.apps.education.fr/anki-templates/wk-style/saisir-la-reponse
  
  The script hijacking the Anki answer check to make it a nice red/green div comes from :
  https://gist.github.com/hinekidori/4085a1222af572057f1058d43cfce773
-->

{{FrontSide}}

<div id="correctAnswer">{{Recto}}</div>
<script>
  //Script for modifying 'Show Answer' behavior for Input types.
  var htmlTextNodes = [];
  var innerHTMLText = [];
  var htmlNodeLength = document.getElementById('typeans').childNodes.length;
  var typedAnswer;
  var correctAnswer;
  var firstBr = null;
  var secondBr;

  function removeAccentsAndUpperCase(inputString) {
    const normalizedString = inputString.normalize('NFD').replace(/[\u0300-\u036f]/g, '');
    const cleanedString = normalizedString.replace(/[^a-zA-Z0-9]/g, '');
    const uppercasedString = cleanedString.toUpperCase();
    return uppercasedString;
  }

  //capture each node to array
  for (i = 0; i < htmlNodeLength; i++) {

    htmlTextNodes[i] = document.getElementById('typeans').childNodes[i];
    innerHTMLText[i] = document.getElementById('typeans').childNodes[i].innerHTML;

    //locate <br> tags for output change markers
    if (document.getElementById('typeans').childNodes[i].nodeName == "BR") {
      if (firstBr != null) {
        secondBr = i;
      } else {
        firstBr = i;
      };
    };
  };

  //If answer is correct, firstBr will still be null, so must set to length of typeans.childNode
  if (firstBr == null) {
    firstBr = htmlNodeLength;
  };
  //assemble typed and correct answer strings
  typedAnswer = innerHTMLText.slice(0, firstBr).join("");
  var corr = document.getElementById('correctAnswer');
  correctAnswer = corr.innerText;
  //Modify answer output
  if (removeAccentsAndUpperCase(typedAnswer) === removeAccentsAndUpperCase(correctAnswer)) {
    var c = "<div id='correct'>" + typedAnswer.replace(/-/g, " ") + "</div>";
    var d = document.getElementById('typeans');
    d.innerHTML = c;
    document.getElementById("correctAnswer").style.display = "none";
  } else {
    var e = "<div id='incorrect'>" + typedAnswer.replace(/-/g, "") + "</div>";
    var f = document.getElementById('typeans');
    f.innerHTML = e;
  };

</script>